Index: issm/trunk/src/jl/usr/classes.jl
===================================================================
--- issm/trunk/src/jl/usr/classes.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/classes.jl	(revision 26744)
@@ -0,0 +1,305 @@
+using Printf
+
+#Model fields
+#Mesh {{{
+abstract type AbstractMesh end
+mutable struct Mesh2dTriangle <: AbstractMesh
+	numberofvertices::Int64
+	numberofelements::Int64
+	x::Vector{Float64}
+	y::Vector{Float64}
+	elements::Matrix{Int64}
+	segments::Matrix{Int64}
+	vertexonboundary::Vector{Bool}
+end
+function Mesh2dTriangle() #{{{
+	return Mesh2dTriangle( 0, 0, Vector{Float64}(undef,0), Vector{Float64}(undef, 0), Matrix{Int64}(undef, 0, 0), Matrix{Int64}(undef, 0, 0), Vector{Bool}(undef,0))
+end# }}}
+function Base.show(io::IO, this::Mesh2dTriangle)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+mutable struct Mesh3dPrism{T} <: AbstractMesh
+	numberofvertices::Int64
+	numberofelements::Int64
+	numberoflayers::Int64
+	x::Vector{Float64}
+	y::Vector{Float64}
+	z::Vector{Float64}
+	elements::Matrix{Int64}
+	segments::Matrix{Int64}
+	vertexonboundary::Vector{Bool}
+end
+function Mesh3dPrism() #{{{
+	return Mesh3dPrism( 0, 0, 0, Vector{Float64}(undef,0), Vector{Float64}(undef,0), Vector{Float64}(undef,0), Matrix{Int64}(undef, 0, 0), Matrix{Int64}(undef, 0, 0), Vector{Bool}(undef,0))
+end# }}}
+#}}}
+#Geometry{{{
+mutable struct Geometry
+	surface::Vector{Float64}
+	base::Vector{Float64}
+	thickness::Vector{Float64}
+	bed::Vector{Float64}
+end
+function Geometry() #{{{
+	return Geometry( Vector{Float64}(undef,0), Vector{Float64}(undef,0), Vector{Float64}(undef,0), Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::Geometry)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+#}}}
+#Mask {{{
+mutable struct Mask
+	ocean_levelset::Vector{Float64}
+	ice_levelset::Vector{Float64}
+end
+function Mask() #{{{
+	return Mask( Vector{Float64}(undef,0), Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::Mask)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+#}}}
+#Initialization{{{
+mutable struct Initialization
+	vx::Vector{Float64}
+	vy::Vector{Float64}
+end
+function Initialization() #{{{
+	return Initialization( Vector{Float64}(undef,0), Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::Initialization)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+#}}}
+#Stressbalance {{{
+mutable struct Stressbalance
+	spcvx::Vector{Float64}
+	spcvy::Vector{Float64}
+	restol::Float64
+	reltol::Float64
+	abstol::Float64
+	maxiter::Int64
+end
+function Stressbalance() #{{{
+	return Stressbalance( Vector{Float64}(undef,0), Vector{Float64}(undef,0), 1.e-4, 0.01, 10., 100)
+end# }}}
+function Base.show(io::IO, this::Stressbalance)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+#}}}
+#Constants{{{
+mutable struct Constants
+	g::Float64
+	yts::Float64
+end
+function Constants() #{{{
+	return Constants( 9.81,  365*24*3600.)
+end# }}}
+function Base.show(io::IO, this::Constants)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Materials {{{
+mutable struct Materials
+	rho_ice::Float64
+	rho_water::Float64
+	rho_freshwater::Float64
+	mu_water::Float64
+	heatcapacity::Float64
+	latentheat::Float64
+	thermalconductivity::Float64
+	temperateiceconductivity::Float64
+	effectiveconductivity_averaging::Int64
+	meltingpoint::Float64
+	beta::Float64
+	mixed_layer_capacity::Float64
+	thermal_exchange_velocity::Float64
+	rheology_B::Vector{Float64}
+	rheology_n::Vector{Float64}
+	rheology_law::String
+end
+function Materials() #{{{
+	return Materials(917., 1023., 1000., 0.001787, 2093., 3.34*10^5, 2.4, .24, 1, 273.15, 9.8*10^-8, 3974., 1.00*10^-4, Vector{Float64}(undef,0), Vector{Float64}(undef,0), "Cuffey")
+end# }}}
+function Base.show(io::IO, this::Materials)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Friction {{{
+abstract type AbstractFriction end
+mutable struct BuddFriction <: AbstractFriction
+	coefficient::Vector{Float64}
+end
+function BuddFriction() #{{{
+	return BuddFriction(Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::BuddFriction)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+mutable struct WeertmanFriction <: AbstractFriction
+	C::Vector{Float64}
+	m::Vector{Float64}
+end
+# }}}
+#Basalforcings {{{
+mutable struct Basalforcings
+	groundedice_melting_rate::Vector{Float64}
+	floatingice_melting_rate::Vector{Float64}
+end
+function Basalforcings() #{{{
+	return Basalforcings( Vector{Float64}(undef,0), Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::Basalforcings)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Surfaceforcings {{{
+mutable struct SMBforcings
+	mass_balance::Vector{Float64}
+end
+function SMBforcings() #{{{
+	return SMBforcings( Vector{Float64}(undef,0))
+end# }}}
+function Base.show(io::IO, this::SMBforcings)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Timestepping{{{
+abstract type AbstractTimestepping end
+mutable struct Timestepping <: AbstractTimestepping
+	start_time::Float64
+	final_time::Float64
+	time_step::Float64
+end
+function Timestepping() #{{{
+	return Timestepping( 0., 0., 0.)
+end# }}}
+function Base.show(io::IO, this::Timestepping)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Masstransport {{{
+mutable struct Masstransport
+	spcthickness::Vector{Float64}
+	min_thickness::Float64
+	stabilization::Int64
+end
+function Masstransport() #{{{
+	return Masstransport( Vector{Float64}(undef,0), 10.0, 1)
+end# }}}
+function Base.show(io::IO, this::Masstransport)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+#Transient {{{
+mutable struct Transient
+	issmb::Bool
+	ismasstransport::Bool
+	isstressbalance::Bool
+	isgroundingline::Bool
+	ismovingfront::Bool
+end
+function Transient() #{{{
+	return Transient( true, true, true, true, true)
+end# }}}
+function Base.show(io::IO, this::Transient)# {{{
+	IssmStructDisp(io, this)
+end# }}}
+# }}}
+
+#Model structure
+mutable struct model
+	mesh::AbstractMesh
+	geometry::Geometry
+	mask::Mask
+	materials::Materials
+	initialization::Initialization
+	stressbalance::Stressbalance
+	constants::Constants
+	results::Dict
+	friction::AbstractFriction
+	basalforcings::Basalforcings
+	smb::SMBforcings
+	timestepping::Timestepping
+	masstransport::Masstransport
+	transient::Transient
+end
+function model() #{{{
+	return model( Mesh2dTriangle(), Geometry(), Mask(), Materials(),
+					 Initialization(),Stressbalance(), Constants(), Dict(),
+					 BuddFriction(), Basalforcings(), SMBforcings(), Timestepping(),
+					 Masstransport(), Transient())
+end#}}}
+function model(matmd::Dict) #{{{
+
+	#initialize output
+	md = model()
+
+	#Loop over all possible fields
+	for name1 in keys(matmd)
+		if !(Symbol(name1) in fieldnames(model))
+			println("could not recover md.",name1)
+			continue
+		end
+		mdfield  = getfield(md,Symbol(name1))
+		matfield = matmd[name1]
+		for name2 in keys(matfield)
+			if !(Symbol(name2) in fieldnames(typeof(mdfield)))
+				println("could not recover md.",name1,".",name2)
+				continue
+			end
+			value_matlab = matfield[name2]
+			value_julia  = getfield(mdfield, Symbol(name2))
+
+			if typeof(value_matlab)==typeof(value_julia)
+				setfield!(mdfield, Symbol(name2), value_matlab)
+
+			elseif typeof(value_matlab)==Float64 && typeof(value_julia)==Int64
+				setfield!(mdfield, Symbol(name2), Int64(value_matlab))
+
+			elseif typeof(value_matlab)==Float64 && typeof(value_julia)==Bool
+				setfield!(mdfield, Symbol(name2), Bool(value_matlab))
+
+			elseif typeof(value_matlab)==Matrix{Float64} && typeof(value_julia)==Vector{Float64}
+				if(size(value_matlab,2)!=1) error("only one column expected") end
+				setfield!(mdfield, Symbol(name2), value_matlab[:,1])
+
+			elseif typeof(value_matlab)==Matrix{Float64} && typeof(value_julia)==Matrix{Int64}
+				matrix = Matrix{Int64}(undef,size(value_matlab))
+				for i in 1:length(value_matlab) matrix[i] = Int64(value_matlab[i]) end
+				setfield!(mdfield, Symbol(name2), matrix)
+
+			elseif typeof(value_matlab)==Matrix{Float64} && typeof(value_julia)==Vector{Bool}
+				if(size(value_matlab,2)!=1) error("only one column expected") end
+				vector = Vector{Bool}(undef,size(value_matlab,1))
+				for i in 1:length(vector) vector[i] = Bool(value_matlab[i]) end
+				setfield!(mdfield, Symbol(name2), vector)
+
+			else
+				error("Don't know how to convert ",typeof(value_matlab)," to ",typeof(value_julia))
+			end
+		end
+	end
+
+	return md
+end#}}}
+function Base.show(io::IO, md::model)# {{{
+
+	compact = get(io, :compact, false)
+
+	println(io,"Model:")
+	@printf "%19s: %-26s -- %s\n" "mesh" typeof(md.mesh) "mesh properties"
+	@printf "%19s: %-26s -- %s\n" "geometry" typeof(md.geometry) "surface elevation, bedrock topography, ice thickness,..."
+	@printf "%19s: %-26s -- %s\n" "mask" typeof(md.mask) "defines grounded and floating regions"
+	@printf "%19s: %-26s -- %s\n" "materials" typeof(md.materials) "material properties"
+	@printf "%19s: %-26s -- %s\n" "initialization" typeof(md.initialization) "initial state"
+	@printf "%19s: %-26s -- %s\n" "constants" typeof(md.constants) "physical constants"
+	@printf "%19s: %-26s -- %s\n" "friction" typeof(md.friction) "basal friction"
+	@printf "%19s: %-26s -- %s\n" "basalforcings" typeof(md.basalforcings) "basal forcings"
+	@printf "%19s: %-26s -- %s\n" "smb" typeof(md.smb) "surface mass balance"
+	@printf "%19s: %-26s -- %s\n" "timestepping" typeof(md.timestepping) "time stepping for transient simulations"
+	@printf "%19s: %-26s -- %s\n" "stressbalance" typeof(md.stressbalance) "parameters stress balance simulations"
+	@printf "%19s: %-26s -- %s\n" "masstransport" typeof(md.masstransport) "parameters mass transport simulations"
+	@printf "%19s: %-26s -- %s\n" "transient" typeof(md.transient) "parameters for transient simulations"
+
+end# }}}
Index: issm/trunk/src/jl/usr/exp.jl
===================================================================
--- issm/trunk/src/jl/usr/exp.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/exp.jl	(revision 26744)
@@ -0,0 +1,234 @@
+#for exptool, look into this http://juliaplots.org/MakieReferenceImages/gallery//mouse_picking/index.html
+
+#exp object definition, constructor, and disp
+mutable struct ExpStruct #{{{
+	name::String
+	nods::Int32
+	density::Float64
+	x::Vector{Float64}
+   y::Vector{Float64}
+	closed::Bool
+end  #}}}
+function ExpStruct() #{{{
+	return ExpStruct("",0, 0., Vector{Float64}(undef,0), Vector{Float64}(undef,0), false)
+end# }}}
+function Base.show(io::IO, exp::ExpStruct)# {{{
+
+	compact = get(io, :compact, false)
+
+	println(io,"ExpStruct:")
+	for name in fieldnames(typeof(exp))
+		a=getfield(exp,name)
+		print(io,"   $(name) = ")
+		if !isempty(a)
+			if compact && eltype(a)<:Number && length(a)>3
+				println(io, typeof(a), " of size ", size(a))
+			else
+				println(io,a)
+			end
+		else
+			println(io,"empty")
+		end
+	end
+end# }}}
+
+#methods
+#expread {{{
+"""
+	EXPREAD - read a file exp and build a Structure
+
+	This function reads an *.exp* and builds a structure containing the fields x
+	and y corresponding to the coordinates, one for the filename of the exp
+	file, for the density, for the nodes, and a field 'closed' to indicate if the
+	domain is closed.
+
+	Usage:
+		exp=expread(filename)
+
+# Examples:
+```julia-repl
+julia> exp=expread('domainoutline.exp')
+```
+
+# Arguments:
+- filename: the ARGUS file to read
+"""
+function expread(filename::String)
+
+	#initialize output
+	contours = Vector{ExpStruct}(undef, 0)
+
+	#open file
+	f = open(filename, "r") do f
+
+		#initialize some variables
+		nprof = 0
+		line = 1
+
+		while !eof(f)
+
+			#read first line
+			A = readline(f); line += 1
+
+			#if isempty, go to the next line and try again
+			if isempty(A)
+				continue
+			else
+				#initialize new profile
+				nprof += 1 
+				exp = ExpStruct();
+			end
+
+			#extract profile name
+			if A[1:8]!="## Name:"
+				println("line $(line): $(A)")
+				error("Unexpected exp file formatting") 
+			end
+			if length(A)>8
+				exp.name = A[9:end]
+			end
+
+			#read Icon
+			A = readline(f); line += 1
+			if A[1:8]!="## Icon:" error("Unexpected exp file formatting") end
+
+			#read Info
+			A = readline(f); line += 1
+			if A[1:14]!="# Points Count"
+				println("line $(line): $(A)")
+				error("Unexpected exp file formatting") 
+			end
+
+			#Reads number of nods and density
+			A = readline(f); line += 1
+			A = parse.(Float64, split(A))
+			if length(A) != 2 error("Unexpected exp file formatting") end
+			exp.nods = A[1]; exp.density = A[2]
+
+			#Allocate arrays
+			if exp.nods<=0 error("Unexpected exp file formatting") end
+			exp.x = Vector{Float64}(undef,exp.nods)
+			exp.y = Vector{Float64}(undef,exp.nods)
+
+			#Read coordinates
+			A = readline(f); line += 1
+			if A[1:13]!="# X pos Y pos" error("Unexpected exp file formatting") end
+			for i in 1:exp.nods
+				A = readline(f); line += 1
+				A = parse.(Float64, split(A))
+				if length(A) != 2 error("Unexpected exp file formatting") end
+				if any(isnan.(A)) error("NaNs found in coordinate") end
+				exp.x[i] = A[1]; exp.y[i] = A[2]
+			end
+
+			#check if closed
+			if exp.nods>1 && exp.x[1]==exp.x[end] && exp.y[1]==exp.y[end]
+				exp.closed = true
+			else
+				exp.closed = false
+			end
+
+			#add profile to list
+			push!(contours, exp)
+		end
+	end
+
+	return contours
+end# }}}
+#ContourToNodes{{{
+"""
+	ContourToNodes - Flag points that are in contour
+
+   More doc to come later....
+
+	Usage:
+		exp=expread(filename)
+
+# Examples:
+```julia-repl
+julia> exp=expread('domainoutline.exp')
+```
+
+# Arguments:
+- filename: the ARGUS file to read
+"""
+function ContourToNodes(x::Vector{Float64},y::Vector{Float64},filename::String,edgevalue::Float64)
+
+	#Read input file
+	contours = expread(filename)
+
+	#Initialize output
+	nbpts = length(x)
+	flags = zeros(Bool,nbpts)
+
+	#Loop over contours
+	for c in 1:length(contours)
+
+		#Get current contours
+		contour = contours[c]
+		xp      = contour.x
+		yp      = contour.y
+
+		#Check that we are within box
+		xmin = minimum(xp); xmax = maximum(xp)
+		ymin = minimum(yp); ymax = maximum(yp)
+
+		#Loop over all points provided
+		for ii in 1:nbpts
+
+			#If this node is already within one of the contours, do not change it
+			if(flags[ii]) continue end
+
+			#Are we within bounds?
+			if(x[ii]<xmin || x[ii]>xmax || y[ii]<ymin || y[ii]>ymax) continue end
+
+			#we are potentially inside... perform pnpoly test
+			flags[ii] = pnpoly(xp, yp, x[ii], y[ii], edgevalue)
+		end
+	end
+	
+	return flags
+end# }}}
+
+function pnpoly(xp::Vector{Float64},yp::Vector{Float64},x::Float64,y::Float64,edgevalue::Float64) #{{{
+
+	npol = length(xp)
+
+	#Do we need to test for colinearity?
+	if(edgevalue!=2)
+		i = 1
+		j = npol
+		while(i<=npol)
+
+			n1 = (yp[i]-yp[j])^2 + (xp[i]-xp[j])^2
+			n2 = (y-yp[j])^2 + (x-xp[j])^2
+
+			normp=sqrt(n1*n2)
+			scalar=(yp[i]-yp[j])*(y-yp[j])+(xp[i]-xp[j])*(x-xp[j])
+
+			if (scalar == normp)
+				if (n2<=n1)
+					return edgevalue
+				end
+			end
+
+			j =  i
+			i += 1
+		end
+	end
+
+	#second test : point is neither on a vertex, nor on a side, where is it ?
+	i = 1
+	j = npol
+	c = false
+	while(i<=npol)
+		if (((yp[i]<=y && y<yp[j]) || (yp[j]<=y && y<yp[i])) &&
+            (x < (xp[j] - xp[i]) * (y - yp[i]) / (yp[j] - yp[i]) + xp[i]))
+         c = !c
+		end
+
+		j =  i
+		i += 1
+	end
+	return c
+end# }}}
Index: issm/trunk/src/jl/usr/parameterization.jl
===================================================================
--- issm/trunk/src/jl/usr/parameterization.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/parameterization.jl	(revision 26744)
@@ -0,0 +1,54 @@
+# setmask {{{
+"""
+SETMASK - establish boundaries between grounded and floating ice.
+
+   By default, ice is considered grounded. The contour floatingicename defines nodes 
+   for which ice is floating. The contour groundedicename defines nodes inside an floatingice, 
+   that are grounded (ie: ice rises, islands, etc ...)
+   All input files are in the Argus format (extension .exp).
+
+   Usage:
+      md=setmask(md,floatingicename,groundedicename)
+
+   Examples:
+      md=setmask(md,'all','');
+      md=setmask(md,'Iceshelves.exp','Islands.exp');
+"""
+function setmask(md::model,floatingicename::String,groundedicename::String)
+
+	elementonfloatingice = FlagElements( md, floatingicename)
+	elementongroundedice = FlagElements( md, groundedicename)
+
+	elementonfloatingice = convert( Array{Float64}, (elementonfloatingice.>0) .&  (elementongroundedice.==0.))
+	elementongroundedice = convert( Array{Float64}, elementonfloatingice.==0.)
+
+	vertexonfloatingice=zeros(md.mesh.numberofvertices)
+	vertexongroundedice=zeros(md.mesh.numberofvertices)
+
+	vertexongroundedice[md.mesh.elements[findall(elementongroundedice.>0),:]] .= 1.
+	vertexonfloatingice[findall(vertexongroundedice.==0.)] .= 1.
+
+	#define levelsets
+	md.mask.ocean_levelset = vertexongroundedice
+	md.mask.ocean_levelset[findall(vertexongroundedice .==0.)] .= -1.
+	md.mask.ice_levelset = -1*ones(md.mesh.numberofvertices)
+
+	return md
+end
+#}}}
+# FlagElements {{{
+function FlagElements(md::model,region::String)
+
+	if isempty(region)
+		flags = zeros(md.mesh.numberofelements)
+	elseif region == "all"
+		flags = ones(md.mesh.numberofelements)
+	else
+		xcenter = md.mesh.x[md.mesh.elements]*[1;1;1]/3
+		ycenter = md.mesh.y[md.mesh.elements]*[1;1;1]/3
+		flags = ContourToNodes(xcenter, ycenter, region, 2.)
+	end
+
+	return flags
+end
+#}}}
Index: issm/trunk/src/jl/usr/plotmodel.jl
===================================================================
--- issm/trunk/src/jl/usr/plotmodel.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/plotmodel.jl	(revision 26744)
@@ -0,0 +1,68 @@
+import ColorSchemes.jet
+using  GLMakie
+using .ISSM
+
+function plotmodel( md::model, data::Vector, showvertices::Bool=false, showfacets::Bool=true)
+
+	vertexcolor  = :black
+	facetcolor   = :blue
+
+	if data isa AbstractVector
+
+		if length(data)==md.mesh.numberofelements
+			# vector of polygons
+			x = md.mesh.x
+			y = md.mesh.y
+			index = md.mesh.elements
+			ps = [Makie.GeometryBasics.Polygon([Point2(x[index[i,1]], y[index[i,1]]), Point2(x[index[i,2]], y[index[i,2]]), Point2(x[index[i,3]], y[index[i,3]])])
+					for i in 1:md.mesh.numberofelements]
+
+			fig, ax, h = Makie.poly(ps, color = data, colormap = jet)
+
+			#Add colorbar
+			Colorbar(fig[1, 2], limits = (minimum(data), maximum(data)), colormap = jet)
+		elseif length(data)==md.mesh.numberofvertices
+			fig, ax, h = Makie.mesh( [md.mesh.x md.mesh.y], md.mesh.elements, shading = false, color = data, colormap = jet)
+
+			#Add colorbar
+			#Colorbar(fig[1, 2], h, width=25)
+		else
+			error("data of size "*string(length(data))*" not supported yet!")
+		end
+	else
+		# default to single color
+		@assert length(data)==1
+		fig, ax, h = Makie.mesh( [md.mesh.x md.mesh.y], md.mesh.elements, shading = false, color = data, colormap = jet)
+	end
+
+	if showfacets
+		Makie.wireframe!(ax, h[1][], color=facetcolor)
+	end
+
+	if showvertices
+		Makie.scatter!( [md.mesh.x md.mesh.y], markersize = 4, color = vertexcolor)
+	end
+
+	return fig
+end
+
+function plotmodel(md::model,data::BitVector) #{{{
+
+	println("Converting BitVector to Vector")
+	data2 = Vector{Float64}(undef,size(data))
+	for i in 1:length(data)
+		data2[i] = Float64(data[i])
+	end
+
+	plotmodel(md,data2)
+
+end#}}}
+function plotmodel(md::model,data::String) #{{{
+
+	if(data=="mesh")
+		poly([md.mesh.x md.mesh.y], md.mesh.elements, strokewidth=1, shading=false)
+	else
+		error(data, " plot not supported yet")
+	end
+
+end#}}}
Index: issm/trunk/src/jl/usr/triangle.jl
===================================================================
--- issm/trunk/src/jl/usr/triangle.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/triangle.jl	(revision 26744)
@@ -0,0 +1,178 @@
+
+#Class Triangle's triangulateio
+mutable struct CTriangulateIO #{{{
+
+    pointlist :: Ptr{Cdouble}
+    pointattributelist :: Ptr{Cdouble}
+    pointmarkerlist :: Ptr{Cint}
+    numberofpoints :: Cint
+    numberofpointattributes :: Cint
+
+    trianglelist :: Ptr{Cint}
+    triangleattributelist :: Ptr{Cdouble}
+    trianglearealist :: Ptr{Cdouble}
+    neighborlist :: Ptr{Cint}
+    numberoftriangles :: Cint
+    numberofcorners :: Cint
+    numberoftriangleattributes :: Cint
+
+    segmentlist :: Ptr{Cint}
+    segmentmarkerlist :: Ptr{Cint}
+    numberofsegments :: Cint
+
+    holelist :: Ptr{Cdouble}
+    numberofholes :: Cint
+
+    regionlist :: Ptr{Cdouble}
+    numberofregions :: Cint
+
+    edgelist :: Ptr{Cint}
+    edgemarkerlist :: Ptr{Cint}
+    normlist :: Ptr{Cdouble}
+    numberofedges :: Cint
+ end  #}}}
+function CTriangulateIO() #{{{
+	return CTriangulateIO(C_NULL, C_NULL, C_NULL, 0, 0,
+								 C_NULL, C_NULL, C_NULL, C_NULL, 0, 0, 0,
+								 C_NULL, C_NULL, 0,
+								 C_NULL, 0,
+								 C_NULL, 0,
+								 C_NULL, C_NULL, C_NULL, 0)
+end# }}}
+function Base.show(io::IO, tio::CTriangulateIO)# {{{
+	println(io,"CTriangulateIO(")
+	for name in fieldnames(typeof(tio))
+		a=getfield(tio,name)
+		print(io,"$(name) = ")
+		println(io,a)
+	end
+	println(io,")")
+end# }}}
+
+using Printf #needed for sprintf
+
+"""
+TRIANGLE - create model mesh using the triangle package
+
+	This function creates a model mesh using Triangle and a domain outline, to
+	within a certain resolution
+#Arguments
+ - md is a model tuple
+ - domainname is the name of an Argus domain outline file
+ - resolution:  is a characteristic length for the mesh (same unit as the domain outline unit)
+
+# Usage:
+ - md=triangle(md,domainname,resolution)
+# Examples:
+ - md=triangle(md,'DomainOutline.exp',1000);
+ - md=triangle(md,'DomainOutline.exp','Rifts.exp',1500);
+"""
+function triangle(md::model,domainname::String,resolution::Float64) #{{{
+
+	#read input file
+	contours = expread(domainname)
+	area     = resolution^2
+
+	#Initialize i/o structures
+	ctio_in  = CTriangulateIO();
+	ctio_out = CTriangulateIO();
+	vor_out  = CTriangulateIO();
+
+	#Construct input structure
+	numberofpoints   = 0
+	numberofsegments = 0
+	for i in 1:length(contours)
+		numberofpoints   += contours[i].nods-1
+		numberofsegments += contours[i].nods-1
+	end
+	numberofpointattributes = 1
+
+	pointlist=Array{Cdouble,2}(undef,2,numberofpoints)
+	count = 0
+	for i in 1:length(contours)
+		nods = contours[i].nods
+		pointlist[1,count+1:count+nods-1] = contours[i].x[1:end-1]
+		pointlist[2,count+1:count+nods-1] = contours[i].y[1:end-1]
+		count += (nods-1)
+	end
+	pointattributelist=Array{Cdouble,1}(undef,numberofpoints)
+	pointmarkerlist=Array{Cint,1}(undef,numberofpoints)
+	for i in 1:numberofpoints
+		pointmarkerlist[i]=0
+		pointattributelist[i]=0.
+	end
+
+	counter=0;
+   backcounter=0;
+	segmentlist=Array{Cint,2}(undef,2,numberofsegments)
+	segmentmarkerlist=Array{Cint,1}(undef,numberofsegments)
+	segmentmarkerlist[:].=0
+	for i in 1:length(contours)
+		nods = contours[i].nods
+		segmentlist[1,counter+1:counter+nods-2] = collect(counter+0:counter+nods-3)
+		segmentlist[2,counter+1:counter+nods-2] = collect(counter+1:counter+nods-2)
+		counter+=nods-2
+		#close profile
+		segmentlist[1,counter+1]=counter
+		segmentlist[2,counter+1]=backcounter
+		counter+=1
+		backcounter=counter
+	end
+
+	numberofregions = 0
+	numberofholes = length(contours)-1
+	holelist = Array{Cdouble,2}(undef,2,numberofholes)
+	if numberofholes>0
+		 for i in 2:length(contours)
+			 xA=contours[i].x[1]; xB=contours[i].x[end-1]
+			 yA=contours[i].y[1]; yB=contours[i].y[end-1]
+			 xC=(xA+xB)/2;        yC=(yA+yB)/2;
+			 xD=xC+tan(10. /180. *pi)*(yC-yA);
+			 yD=yC+tan(10. /180. *pi)*(xA-xC);
+			 xE=xC-tan(10. /180. *pi)*(yC-yA);
+			 yE=yC-tan(10. /180. *pi)*(xA-xC);
+			 holelist[1,i-1] = xD
+			 holelist[2,i-1] = yD
+		 end
+	end
+
+	#based on this, prepare input structure
+	ctio_in.numberofpoints = numberofpoints
+	ctio_in.pointlist=pointer(pointlist)
+	ctio_in.numberofpointattributes=numberofpointattributes
+	ctio_in.pointattributelist=pointer(pointattributelist)
+	ctio_in.pointmarkerlist=pointer(pointmarkerlist)
+	ctio_in.numberofsegments=numberofsegments
+	ctio_in.segmentlist=pointer(segmentlist)
+	ctio_in.segmentmarkerlist = pointer(segmentmarkerlist)
+	ctio_in.numberofholes=numberofholes
+	ctio_in.holelist=pointer(holelist)
+	ctio_in.numberofregions=0
+
+	#Call triangle using ISSM's default options
+	triangle_switches = "pQzDq30ia"*@sprintf("%lf",area) #replace V by Q to quiet down the logging
+	#rc=ccall( (:triangulate,"libtriangle"),
+	rc=ccall( (:triangulate,issmdir()*"/externalpackages/triangle/src/libtriangle.dylib"),
+				Cint, ( Cstring, Ref{CTriangulateIO}, Ref{CTriangulateIO}, Ref{CTriangulateIO}),
+				triangle_switches, Ref(ctio_in), Ref(ctio_out), Ref(vor_out))
+
+	#post process output
+	points    = convert(Array{Cdouble,2}, Base.unsafe_wrap(Array, ctio_out.pointlist,    (2,Int(ctio_out.numberofpoints)), own=true))'
+	triangles = convert(Array{Cint,2},    Base.unsafe_wrap(Array, ctio_out.trianglelist, (3,Int(ctio_out.numberoftriangles)), own=true))' .+1
+	segments  = convert(Array{Cint,2},    Base.unsafe_wrap(Array, ctio_out.segmentlist,  (2,Int(ctio_out.numberofsegments)), own=true))' .+1
+
+	#assign output
+	md.mesh = Mesh2dTriangle()
+	md.mesh.numberofvertices = ctio_out.numberofpoints
+	md.mesh.numberofelements = ctio_out.numberoftriangles
+	md.mesh.x                = points[:,1]
+	md.mesh.y                = points[:,2]
+	md.mesh.elements         = triangles
+	md.mesh.segments         = segments
+
+	#post processing
+	md.mesh.vertexonboundary = zeros(Bool,md.mesh.numberofvertices)
+	md.mesh.vertexonboundary[md.mesh.segments] .= true
+
+   return md
+end#}}}
